clear all
close all
%
% first get all FEM data
%
intext='Circ3S';
disp(sprintf('%6s_out.mat',intext))
R=load(sprintf('%6s_out.mat',intext))
dirpoints=[R.p(1,R.bpind)' R.p(2,R.bpind)'];
ndirpoints=length(dirpoints(:,1));
lappoints=[R.p(1,R.ppind)' R.p(2,R.ppind)'];
nlappoints=length(lappoints(:,1));
barypoints=[R.bary(1,:)' R.bary(2,:)'];
nbarypoints=length(barypoints(:,1));
trialpoints=[R.p(1,:)' R.p(2,:)'];
ntrialpoints=length(trialpoints(:,1))
Cnode=R.Cnode;
Cbary=R.Cbary;
sCnode=size(Cnode)
sCbary=size(Cbary)
plot(barypoints(:,1),barypoints(:,2),'.')
% hold on
% plot(lappoints(:,1),lappoints(:,2),'.')
hold on
plot(dirpoints(:,1),dirpoints(:,2),'x')
hold on
plot(trialpoints(:,1),trialpoints(:,2),'o')
axis square
legend('barycentric','Dirichlet','nodes',-1)
% 
k=R.indzero
evalpoint=lappoints(k,:) % pick a node that is not Dirichlet, for evaluation of norm
%
SobOrder=7
SobScale=1
bandwidth=15
%
% we do it for the barycentric case first
%
Cvector=Cbary(k,:)';
normfembary=ErrorNormOfVector(Cvector, evalpoint, barypoints, dirpoints,  SobOrder, SobScale)
global solution
solution='parabola';
[vald, lapvald]=mysolution(dirpoints(:,1),dirpoints(:,2));
[valp, lapvalp]=mysolution(trialpoints(:,1),trialpoints(:,2));
Dirdat=vald;
PDEdat=lapvalp;
uc=zeros(length(trialpoints(:,1)),1);
uc(R.bpind,1)=Dirdat; 
% size(Dirdat)
% size(PDEdat)
% size(Cnode)
uc(R.ppind,1)=Cnode*[-PDEdat; Dirdat]; % 

% figure
% pdeplot(R.p,R.e,R.t,'xydata',uc,'zdata',uc,'mesh','off');
% title('Solution for f data on nodes');
% 
% figure
% pdeplot(R.p,R.e,R.t,'xydata',valp-uc,'zdata',valp-uc,'mesh','on');
% title('Error for f data on nodes');
% % 
% we now do it for the nodal case 
%
Cvector=Cnode(k,:)';
normfemnode=ErrorNormOfVector(Cvector, evalpoint, trialpoints, dirpoints,  SobOrder, SobScale)
%
% now Kansa on barycenters
%
C=GetKansaRecoveryMatrix(lappoints, dirpoints, barypoints,  'ms', 6, 1);
Cvector=C(k,:)';
normkansabary=ErrorNormOfVector(Cvector, evalpoint, barypoints, dirpoints,  SobOrder, SobScale)
% 
% now Kansa on nodes 
%
C=GetKansaRecoveryMatrix(lappoints, dirpoints, trialpoints,  'ms', 6, 1);
Cvector=C(k,:)';
normkansanode=ErrorNormOfVector(Cvector, evalpoint, trialpoints, dirpoints,  SobOrder, SobScale)
%
% now some symmetric kernel recovery on barypoints
%
C=GetKernelRecoveryMatrix(lappoints, dirpoints, barypoints,  'ms', 6, 1);
Cvector=C(k,:)';
normkernelbary=ErrorNormOfVector(Cvector, evalpoint, barypoints, dirpoints,  SobOrder, SobScale)

C=GetKernelRecoveryMatrix(lappoints, dirpoints, trialpoints,  'ms', 6, 1);
Cvector=C(k,:)';
normkernelnode=ErrorNormOfVector(Cvector, evalpoint, trialpoints, dirpoints,  SobOrder, SobScale)
% 

C=GetLocalKernelRecoveryMatrix(trialpoints, lappoints, dirpoints, 'ms', 6, 0.5, bandwidth);
Cvector=C(k,:)';
normlocalkernelnode=ErrorNormOfVector(Cvector, evalpoint, trialpoints, dirpoints,  SobOrder, SobScale)
%
% now the optimal one on bary points
%
C=GetKernelRecoveryMatrix(lappoints, dirpoints, barypoints, 'ms', SobOrder-1, SobScale);
Cvector=C(k,:)';
normoptbary=ErrorNormOfVector(Cvector, evalpoint, barypoints, dirpoints,  SobOrder, SobScale)
%
% now the optimal one on node points
%
C=GetKernelRecoveryMatrix(lappoints, dirpoints, trialpoints,  'ms', SobOrder-1, SobScale);
Cvector=C(k,:)';
normoptnode=ErrorNormOfVector(Cvector, evalpoint, trialpoints, dirpoints,  SobOrder, SobScale)
%
% now save the results
%
fid=fopen('FEMresults.dat','a')
fprintf(fid,'%6s %3d %10.4e %10.4e %10.4e %10.4e %10.4e %10.4e %10.4e %10.4e %10.4e %10.4e\n',intext, SobOrder, R.h, ...
    normfembary, normfemnode, normkansabary, normkansanode,...
    normkernelbary, normkernelnode, normoptbary, normoptnode, normlocalkernelnode);
fclose(fid)
disp(sprintf('%6s %3d %10.4e %10.4e %10.4e %10.4e %10.4e %10.4e %10.4e %10.4e %10.4e %10.4e\n',intext, SobOrder, R.h, ...
    normfembary, normfemnode, normkansabary, normkansanode,...
    normkernelbary, normkernelnode, normoptbary, normoptnode, normlocalkernelnode));
evalpoint