function C=GetKernelRecoveryMatrix(trialpoints, dirpoints, lappoints, Type, Par, Scale)
%
%  Full discrete recovery matrix generation  
%
global RBFtype;  % type of RBF see frbf.m
global RBFpar;   % parameter of RBF, see frbf.m
global RBFscale; % scale of RBF, see frbf.m
%
RBFtype=Type
RBFscale=Scale
RBFpar=Par;
%
disp('Starting full kernel-based solution')
disp('Building full kernel matrix')
tic
rhs=[-laplacekermat(lappoints, trialpoints); kermat(dirpoints, trialpoints)];
ALL=laplaceXYkermat(lappoints,lappoints);
ALD=-laplacekermat(lappoints, dirpoints);
ADD=kermat(dirpoints,dirpoints);
Amat=[ALL ALD; ALD' ADD];
cond=condest(Amat)    
tim=toc;
disp(sprintf('Elapsed time: %f\n',tim));
disp('Solving full system')
tic
C=(Amat\rhs)';
% C=(pinv(Amat,1.0e-12)*rhs)';
tim=toc;
disp(sprintf('Elapsed time: %f\n',tim));