function C=GetLocalKernelRecoveryMatrix(testpoints, lappoints, dirpoints, Type, Par, Scale, nband)
ndir=length(dirpoints(:,1))
nlap=length(lappoints(:,1))
ntst=length(testpoints(:,1))
%
%  Discrete recovery matrix generation, localized, with bounded bandwidth 
%
%  One equation at each testpoint = nodes or barycenters
global RBFtype;  % type of RBF see frbf.m
global RBFpar;   % parameter of RBF, see frbf.m
global RBFscale; % scale of RBF, see frbf.m
%
RBFtype=Type
RBFscale=Scale
RBFpar=Par;
condexception=0;
%
% Trial points are dirpoints and lappoints.
% The dirpoints are always selected, only the lappoints are restricted for
% small bandwidth.
nband=min(nband, nlap)
dsm=distsqh(lappoints, testpoints); % distance matrix
[ss is]=sort(dsm);
pi=is(1:nband,:); % column holds the neighbor indices of the lappoints neighbors of testpoints
A=sparse(ntst,nlap);
B=zeros(ntst, ndir);
for i=1:ntst
    isi=pi(:,i);
    if nlap==1 % the sort principle does not work if matrices are vectors
        isi=1;
    end
%     figure
%     plot(lappoints(i,1),lappoints(i,2),'rx',trialpoints(isi,1),trialpoints(isi,2),'.')
    rhs=-laplacekermat([lappoints(isi,:); dirpoints], testpoints(i,:));
    Aloc=kermat([lappoints(isi,:); dirpoints] ,[lappoints(isi,:); dirpoints]);
    condloc=condest(Aloc);
    sol=Aloc\rhs;
    A(i,isi)=sol(1:nband,1)';
    B(i,:)=sol(nband+1:end,1)';
end
figure
spy(A)
title(sprintf('Local kernel--based stiffness matrix with bandwidth %d',nband))
C=A\[eye(ntst) -B];


