clear all
close all
fid=fopen('FEMresults.dat','r')
rec=fscanf(fid,'%g %g %g %g %g %g %g %g %g %g %g %g',[12 30])'
for j=3:7
    ind=find(rec(:,2)==j);
    h=rec(ind,3);
    figure
    loglog(h,rec(ind,4),'-rs')
    hold on
    loglog(h,rec(ind,5),'-rd')
    hold on
    loglog(h,rec(ind,10),'-b^')
    hold on
    loglog(h,rec(ind,11),'-bv')
    hold on
    loglog(h,rec(ind,8),'-g>')
    hold on
    loglog(h,rec(ind,9),'-g<')
    hold on
    loglog(h,rec(ind,6),'-m*')
    hold on
    loglog(h,rec(ind,7),'-m+')
    hold on
    loglog(h,rec(ind,12),'-kx')
    
    title(sprintf('Errors in Sobolev space of order %d',j))
    legend('FEMBary','FEMNode','OptBary','OptNode','HOBary','HONode',...
        'KansaBary', 'KansaNode','LocNode', 4)
    xlabel('h')
    Soborder=j
    disp(sprintf('& Circ%1d & Circ%1d & Circ%1d & Circ%1d & Circ%1d \\\\ \n',...
        rec(ind(1),1), rec(ind(2),1), rec(ind(3),1), rec(ind(4),1), rec(ind(5),1)))
    % disp(sprintf('%d %d %d %d %d %d\n',rec(ind(1),2), rec(ind(2),2), rec(ind(3),2), rec(ind(4),2), rec(ind(5),2)))
    i=3; 
    disp(sprintf('h & %8.3e & %8.3e & %8.3e & %8.3e & %8.3e \\\\ \n',...
        rec(ind(1),i), rec(ind(2),i), rec(ind(3),i), ...
        rec(ind(4),i), rec(ind(5),i)))
    i=4; 
    disp(sprintf('FEMBary & %8.3e & %8.3e & %8.3e & %8.3e & %8.3e \\\\ \n',...
        rec(ind(1),i), rec(ind(2),i), rec(ind(3),i), ...
        rec(ind(4),i), rec(ind(5),i)))
    i=5; 
    disp(sprintf('FEMNode & %8.3e & %8.3e & %8.3e & %8.3e & %8.3e \\\\ \n',...
        rec(ind(1),i), rec(ind(2),i), rec(ind(3),i), ...
        rec(ind(4),i), rec(ind(5),i)))
    i=6; 
    disp(sprintf('KansaBary & %8.3e & %8.3e & %8.3e & %8.3e & %8.3e \\\\ \n',...
        rec(ind(1),i), rec(ind(2),i), rec(ind(3),i), ...
        rec(ind(4),i), rec(ind(5),i)))
    i=7; 
    disp(sprintf('KansaNode & %8.3e & %8.3e & %8.3e & %8.3e & %8.3e \\\\  \n',...
        rec(ind(1),i), rec(ind(2),i), rec(ind(3),i), ...
        rec(ind(4),i), rec(ind(5),i)))
    i=8; 
    disp(sprintf('HOBary & %8.3e & %8.3e & %8.3e & %8.3e & %8.3e \\\\  \n',...
        rec(ind(1),i), rec(ind(2),i), rec(ind(3),i), ...
        rec(ind(4),i), rec(ind(5),i)))
    i=9; 
    disp(sprintf('HONode & %8.3e & %8.3e & %8.3e & %8.3e & %8.3e \\\\  \n',...
        rec(ind(1),i), rec(ind(2),i), rec(ind(3),i), ...
        rec(ind(4),i), rec(ind(5),i)))
    i=10; 
    disp(sprintf('OptBary & %8.3e & %8.3e & %8.3e & %8.3e & %8.3e  \\\\ \n',...
        rec(ind(1),i), rec(ind(2),i), rec(ind(3),i), ...
        rec(ind(4),i), rec(ind(5),i)))
    i=11; 
    disp(sprintf('OptNode & %8.3e & %8.3e & %8.3e & %8.3e & %8.3e \\\\ \n',...
        rec(ind(1),i), rec(ind(2),i), rec(ind(3),i), ...
        rec(ind(4),i), rec(ind(5),i)))
    i=12; 
    disp(sprintf('LocNode & %8.3e & %8.3e & %8.3e & %8.3e & %8.3e  \\\\ \n',...
        rec(ind(1),i), rec(ind(2),i), rec(ind(3),i), ...
        rec(ind(4),i), rec(ind(5),i)))
end


fclose(fid);
% fprintf(fid,'%6s %3d %10.4e %10.4e %10.4e %10.4e %10.4e %10.4e %10.4e\n',intext, SobOrder, R.h, ...
% normfembary, normfemnode, normkansabary, normkansanode,...
% normkernelbary, normkernelnode, normoptbary, normoptnode, normlocalkernelnode);
