function normresult=SobNormOfFunctional(LapPoints, LapWeights, DirPoints, DirWeights, SobOrder, SobScale)
%
%  Evaluate norm of functional for Sobolev order 
%
global RBFtype;  % type of RBF see frbf.m
global RBFpar;   % parameter of RBF, see frbf.m
global RBFscale; % scale of RBF, see frbf.m
%
RBFtype='ms';
RBFscale=SobScale;
RBFpar=SobOrder-1;
%%
APD=laplacekermat(LapPoints, DirPoints);
APP=laplaceXYkermat(LapPoints, LapPoints);
ADD=kermat(DirPoints, DirPoints);
a=[LapWeights; DirWeights];

Afull=[APP APD; APD' ADD];
%
% quadratic form with factor for true Sobolev space
%
qf=a'*Afull*a*2^(1-SobOrder)/factorial(SobOrder-1);
normresult=sqrt(abs(qf));
