function [val, lapval]=mysolution(x, y)
% exact solution of Delta u=f, val=u, lapval=f
global solution
switch lower(solution)
    case 'parabola'
        val=x.^2+y.^2;
        lapval=4*ones(size(val));
    case 'sinsin'
        val=sin(pi*x).*sin(pi*y);
        lapval=-2*pi*pi*val;
    case 'intcorner'
        [theta,rho]=cart2pol(x,y);
        val=rho.^2.*sin(2*theta);
        lapval=zeros(size(val));
    otherwise
        error(sprintf('Solution %s not implemented',solution));
end
    